# coding=utf-8
# *** WARNING: this file was generated by pulumigen. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs
from ._enums import *

__all__ = ['DeployArgs', 'Deploy']

@pulumi.input_type
class DeployArgs:
    def __init__(__self__, *,
                 clear_cache: Optional[pulumi.Input['ClearCache']] = None,
                 commit_id: Optional[pulumi.Input[str]] = None,
                 image_url: Optional[pulumi.Input[str]] = None,
                 service_id: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a Deploy resource.
        :param pulumi.Input['ClearCache'] clear_cache: If `clear`, Render clears the service's build cache before deploying. This can be useful if you're experiencing issues with your build.
        :param pulumi.Input[str] commit_id: The SHA of a specific Git commit to deploy for a service. Defaults to the latest commit on the service's connected branch.
               
               Note that deploying a specific commit with this endpoint does not disable autodeploys for the service.
               
               You can toggle autodeploys for your service with the [Update service](https://api-docs.render.com/reference/update-service) endpoint or in the Render Dashboard.
               
               Not supported for cron jobs.
        :param pulumi.Input[str] image_url: The URL of the image to deploy for an image-backed service.
               
               The host, repository, and image name all must match the currently configured image for the service.
        :param pulumi.Input[str] service_id: The ID of the service
        """
        if clear_cache is None:
            clear_cache = 'do_not_clear'
        if clear_cache is not None:
            pulumi.set(__self__, "clear_cache", clear_cache)
        if commit_id is not None:
            pulumi.set(__self__, "commit_id", commit_id)
        if image_url is not None:
            pulumi.set(__self__, "image_url", image_url)
        if service_id is not None:
            pulumi.set(__self__, "service_id", service_id)

    @property
    @pulumi.getter(name="clearCache")
    def clear_cache(self) -> Optional[pulumi.Input['ClearCache']]:
        """
        If `clear`, Render clears the service's build cache before deploying. This can be useful if you're experiencing issues with your build.
        """
        return pulumi.get(self, "clear_cache")

    @clear_cache.setter
    def clear_cache(self, value: Optional[pulumi.Input['ClearCache']]):
        pulumi.set(self, "clear_cache", value)

    @property
    @pulumi.getter(name="commitId")
    def commit_id(self) -> Optional[pulumi.Input[str]]:
        """
        The SHA of a specific Git commit to deploy for a service. Defaults to the latest commit on the service's connected branch.

        Note that deploying a specific commit with this endpoint does not disable autodeploys for the service.

        You can toggle autodeploys for your service with the [Update service](https://api-docs.render.com/reference/update-service) endpoint or in the Render Dashboard.

        Not supported for cron jobs.
        """
        return pulumi.get(self, "commit_id")

    @commit_id.setter
    def commit_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "commit_id", value)

    @property
    @pulumi.getter(name="imageUrl")
    def image_url(self) -> Optional[pulumi.Input[str]]:
        """
        The URL of the image to deploy for an image-backed service.

        The host, repository, and image name all must match the currently configured image for the service.
        """
        return pulumi.get(self, "image_url")

    @image_url.setter
    def image_url(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "image_url", value)

    @property
    @pulumi.getter(name="serviceId")
    def service_id(self) -> Optional[pulumi.Input[str]]:
        """
        The ID of the service
        """
        return pulumi.get(self, "service_id")

    @service_id.setter
    def service_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "service_id", value)


class Deploy(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 clear_cache: Optional[pulumi.Input['ClearCache']] = None,
                 commit_id: Optional[pulumi.Input[str]] = None,
                 image_url: Optional[pulumi.Input[str]] = None,
                 service_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Create a Deploy resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input['ClearCache'] clear_cache: If `clear`, Render clears the service's build cache before deploying. This can be useful if you're experiencing issues with your build.
        :param pulumi.Input[str] commit_id: The SHA of a specific Git commit to deploy for a service. Defaults to the latest commit on the service's connected branch.
               
               Note that deploying a specific commit with this endpoint does not disable autodeploys for the service.
               
               You can toggle autodeploys for your service with the [Update service](https://api-docs.render.com/reference/update-service) endpoint or in the Render Dashboard.
               
               Not supported for cron jobs.
        :param pulumi.Input[str] image_url: The URL of the image to deploy for an image-backed service.
               
               The host, repository, and image name all must match the currently configured image for the service.
        :param pulumi.Input[str] service_id: The ID of the service
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: Optional[DeployArgs] = None,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Create a Deploy resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param DeployArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(DeployArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 clear_cache: Optional[pulumi.Input['ClearCache']] = None,
                 commit_id: Optional[pulumi.Input[str]] = None,
                 image_url: Optional[pulumi.Input[str]] = None,
                 service_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = DeployArgs.__new__(DeployArgs)

            if clear_cache is None:
                clear_cache = 'do_not_clear'
            __props__.__dict__["clear_cache"] = clear_cache
            __props__.__dict__["commit_id"] = commit_id
            __props__.__dict__["image_url"] = image_url
            __props__.__dict__["service_id"] = service_id
            __props__.__dict__["commit"] = None
            __props__.__dict__["created_at"] = None
            __props__.__dict__["finished_at"] = None
            __props__.__dict__["image"] = None
            __props__.__dict__["status"] = None
            __props__.__dict__["trigger"] = None
            __props__.__dict__["updated_at"] = None
        super(Deploy, __self__).__init__(
            'render:services:Deploy',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None) -> 'Deploy':
        """
        Get an existing Deploy resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = DeployArgs.__new__(DeployArgs)

        __props__.__dict__["clear_cache"] = None
        __props__.__dict__["commit"] = None
        __props__.__dict__["commit_id"] = None
        __props__.__dict__["created_at"] = None
        __props__.__dict__["finished_at"] = None
        __props__.__dict__["image"] = None
        __props__.__dict__["image_url"] = None
        __props__.__dict__["status"] = None
        __props__.__dict__["trigger"] = None
        __props__.__dict__["updated_at"] = None
        return Deploy(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="clearCache")
    def clear_cache(self) -> pulumi.Output[Optional['ClearCache']]:
        """
        If `clear`, Render clears the service's build cache before deploying. This can be useful if you're experiencing issues with your build.
        """
        return pulumi.get(self, "clear_cache")

    @property
    @pulumi.getter
    def commit(self) -> pulumi.Output[Optional['outputs.CommitProperties']]:
        return pulumi.get(self, "commit")

    @property
    @pulumi.getter(name="commitId")
    def commit_id(self) -> pulumi.Output[Optional[str]]:
        """
        The SHA of a specific Git commit to deploy for a service. Defaults to the latest commit on the service's connected branch.

        Note that deploying a specific commit with this endpoint does not disable autodeploys for the service.

        You can toggle autodeploys for your service with the [Update service](https://api-docs.render.com/reference/update-service) endpoint or in the Render Dashboard.

        Not supported for cron jobs.
        """
        return pulumi.get(self, "commit_id")

    @property
    @pulumi.getter(name="createdAt")
    def created_at(self) -> pulumi.Output[Optional[str]]:
        return pulumi.get(self, "created_at")

    @property
    @pulumi.getter(name="finishedAt")
    def finished_at(self) -> pulumi.Output[Optional[str]]:
        return pulumi.get(self, "finished_at")

    @property
    @pulumi.getter
    def image(self) -> pulumi.Output[Optional['outputs.ImageProperties']]:
        """
        Image information used when creating the deploy. Not present for Git-backed deploys
        """
        return pulumi.get(self, "image")

    @property
    @pulumi.getter(name="imageUrl")
    def image_url(self) -> pulumi.Output[Optional[str]]:
        """
        The URL of the image to deploy for an image-backed service.

        The host, repository, and image name all must match the currently configured image for the service.
        """
        return pulumi.get(self, "image_url")

    @property
    @pulumi.getter
    def status(self) -> pulumi.Output[Optional['Status']]:
        return pulumi.get(self, "status")

    @property
    @pulumi.getter
    def trigger(self) -> pulumi.Output[Optional['Trigger']]:
        return pulumi.get(self, "trigger")

    @property
    @pulumi.getter(name="updatedAt")
    def updated_at(self) -> pulumi.Output[Optional[str]]:
        return pulumi.get(self, "updated_at")

