# coding=utf-8
# *** WARNING: this file was generated by pulumigen. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['RefreshCustomDomainArgs', 'RefreshCustomDomain']

@pulumi.input_type
class RefreshCustomDomainArgs:
    def __init__(__self__, *,
                 custom_domain_id_or_name: Optional[pulumi.Input[str]] = None,
                 service_id: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a RefreshCustomDomain resource.
        :param pulumi.Input[str] custom_domain_id_or_name: The ID or name of the custom domain
        :param pulumi.Input[str] service_id: The ID of the service
        """
        if custom_domain_id_or_name is not None:
            pulumi.set(__self__, "custom_domain_id_or_name", custom_domain_id_or_name)
        if service_id is not None:
            pulumi.set(__self__, "service_id", service_id)

    @property
    @pulumi.getter(name="customDomainIdOrName")
    def custom_domain_id_or_name(self) -> Optional[pulumi.Input[str]]:
        """
        The ID or name of the custom domain
        """
        return pulumi.get(self, "custom_domain_id_or_name")

    @custom_domain_id_or_name.setter
    def custom_domain_id_or_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "custom_domain_id_or_name", value)

    @property
    @pulumi.getter(name="serviceId")
    def service_id(self) -> Optional[pulumi.Input[str]]:
        """
        The ID of the service
        """
        return pulumi.get(self, "service_id")

    @service_id.setter
    def service_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "service_id", value)


class RefreshCustomDomain(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 custom_domain_id_or_name: Optional[pulumi.Input[str]] = None,
                 service_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Create a RefreshCustomDomain resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] custom_domain_id_or_name: The ID or name of the custom domain
        :param pulumi.Input[str] service_id: The ID of the service
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: Optional[RefreshCustomDomainArgs] = None,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Create a RefreshCustomDomain resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param RefreshCustomDomainArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(RefreshCustomDomainArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 custom_domain_id_or_name: Optional[pulumi.Input[str]] = None,
                 service_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = RefreshCustomDomainArgs.__new__(RefreshCustomDomainArgs)

            __props__.__dict__["custom_domain_id_or_name"] = custom_domain_id_or_name
            __props__.__dict__["service_id"] = service_id
        super(RefreshCustomDomain, __self__).__init__(
            'render:services:RefreshCustomDomain',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None) -> 'RefreshCustomDomain':
        """
        Get an existing RefreshCustomDomain resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = RefreshCustomDomainArgs.__new__(RefreshCustomDomainArgs)

        return RefreshCustomDomain(resource_name, opts=opts, __props__=__props__)

